package edu.lu.uni.serval.tbar.main;

import edu.lu.uni.serval.tbar.TBarFixer;
import edu.lu.uni.serval.tbar.TBarFixer.Granularity;
import edu.lu.uni.serval.tbar.config.Configuration;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

public class MainPerfectFL {

   private static Logger log = LoggerFactory.getLogger(MainPerfectFL.class);
   private static Granularity granularity = Granularity.File;
   // $FF: synthetic field
   private static int[] $SWITCH_TABLE$edu$lu$uni$serval$tbar$TBarFixer$Granularity;


   public static void main(String[] args) {
      if(args.length != 4) {
         System.err.println("Arguments: \n\t<Bug_Data_Path>: the directory of checking out Defects4J bugs. \n\t<Bug_ID>: bug id of each Defects4J bug, such as Chart_1. \n\t<defects4j_Home>: the directory of defects4j git repository.\n\t<isTestFixPatterns>: true - try all fix patterns for each bug, false - perfect fault localization configuration.");
         System.exit(0);
      }

      String bugDataPath = args[0];
      String bugId = args[1];
      String defects4jHome = args[2];
      boolean isTestFixPatterns = Boolean.valueOf(args[3]).booleanValue();
      String granularityStr = "Line";
      System.out.println(bugId);
      if("line".equalsIgnoreCase(granularityStr) || "l".equalsIgnoreCase(granularityStr)) {
         granularity = Granularity.Line;
         if(isTestFixPatterns) {
            Configuration.outputPath = Configuration.outputPath + "FixPatterns/";
         } else {
            Configuration.outputPath = Configuration.outputPath + "PerfectFL/";
         }
      }

      fixBug(bugDataPath, defects4jHome, bugId, isTestFixPatterns);
   }

   public static void fixBug(String bugDataPath, String defects4jHome, String bugIdStr, boolean isTestFixPatterns) {
      String[] elements = bugIdStr.split("_");
      String projectName = elements[0];

      int bugId;
      try {
         bugId = Integer.valueOf(elements[1]).intValue();
      } catch (NumberFormatException var9) {
         System.err.println("Please input correct buggy project ID, such as \"Chart_1\".");
         return;
      }

      TBarFixer fixer = new TBarFixer(bugDataPath, projectName, bugId, defects4jHome);
      fixer.dataType = "TBar";
      fixer.isTestFixPatterns = isTestFixPatterns;
      switch($SWITCH_TABLE$edu$lu$uni$serval$tbar$TBarFixer$Granularity()[granularity.ordinal()]) {
      case 1:
         fixer.granularity = Granularity.Line;
         break;
      case 2:
         fixer.granularity = Granularity.File;
         break;
      default:
         return;
      }

      if(Integer.MAX_VALUE == fixer.minErrorTest) {
         System.out.println("Failed to defects4j compile bug " + bugIdStr);
      } else {
         fixer.metric = Configuration.faultLocalizationMetric;
         fixer.fixProcess();
         int fixedStatus = fixer.fixedStatus;
         switch(fixedStatus) {
         case 0:
            log.info("=======Failed to fix bug " + bugIdStr);
            break;
         case 1:
            log.info("=======Succeeded to fix bug " + bugIdStr);
            break;
         case 2:
            log.info("=======Partial succeeded to fix bug " + bugIdStr);
         }

      }
   }

   // $FF: synthetic method
   static int[] $SWITCH_TABLE$edu$lu$uni$serval$tbar$TBarFixer$Granularity() {
      if($SWITCH_TABLE$edu$lu$uni$serval$tbar$TBarFixer$Granularity != null) {
         return $SWITCH_TABLE$edu$lu$uni$serval$tbar$TBarFixer$Granularity;
      } else {
         int[] var0 = new int[Granularity.values().length];

         try {
            var0[Granularity.FL.ordinal()] = 3;
         } catch (NoSuchFieldError var3) {
            ;
         }

         try {
            var0[Granularity.File.ordinal()] = 2;
         } catch (NoSuchFieldError var2) {
            ;
         }

         try {
            var0[Granularity.Line.ordinal()] = 1;
         } catch (NoSuchFieldError var1) {
            ;
         }

         $SWITCH_TABLE$edu$lu$uni$serval$tbar$TBarFixer$Granularity = var0;
         return var0;
      }
   }
}
